import { Component, Directive, Input, Output, HostListener, HostBinding, EventEmitter, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
export var SuiRadioButton = (function () {
    function SuiRadioButton() {
        this.classes = true;
        this.value = "";
        this.isDisabled = false;
        this.isReadonly = false;
        this.checked = false;
        this.currentValueChange = new EventEmitter(false);
    }
    Object.defineProperty(SuiRadioButton.prototype, "checkedAttribute", {
        get: function () {
            return this.checked ? "" : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiRadioButton.prototype, "isDisabledAttribute", {
        get: function () {
            return this.isDisabled ? "disabled" : null;
        },
        enumerable: true,
        configurable: true
    });
    SuiRadioButton.prototype.onClick = function () {
        if (!this.isDisabled && !this.isReadonly) {
            this.currentValue = this.value;
            this.currentValueChange.emit(this.currentValue);
            this.update();
        }
    };
    SuiRadioButton.prototype.update = function () {
        var _this = this;
        //This is a horrible hack - need to rewrite!
        setTimeout(function () {
            _this.checked = _this.currentValue == _this.value;
        });
    };
    SuiRadioButton.prototype.writeValue = function (value) {
        this.currentValue = value;
        this.update();
    };
    SuiRadioButton.decorators = [
        { type: Component, args: [{
                    selector: 'sui-radio-button[ngModel]',
                    exportAs: 'suiRadioButton',
                    template: "\n<input class=\"hidden\"\n       type=\"checkbox\"\n       [attr.name]=\"name\"\n       [attr.checked]=\"checkedAttribute\"\n       [attr.disabled]=\"isDisabledAttribute\"\n       [ngModel]=\"checked\"\n       (ngModel)=\"currentValue = value\">\n<label>\n    <ng-content></ng-content>\n</label>\n"
                },] },
    ];
    /** @nocollapse */
    SuiRadioButton.ctorParameters = function () { return []; };
    SuiRadioButton.propDecorators = {
        'classes': [{ type: HostBinding, args: ['class.ui',] }, { type: HostBinding, args: ['class.radio',] }, { type: HostBinding, args: ['class.checkbox',] },],
        'name': [{ type: Input },],
        'value': [{ type: Input },],
        'isDisabled': [{ type: Input },],
        'isReadonly': [{ type: HostBinding, args: ['class.read-only',] }, { type: Input },],
        'checked': [{ type: HostBinding, args: ['class.checked',] },],
        'currentValueChange': [{ type: Output },],
        'onClick': [{ type: HostListener, args: ['click',] },],
    };
    return SuiRadioButton;
}());
export var CUSTOM_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(function () { return SuiRadioButtonValueAccessor; }),
    multi: true
};
export var SuiRadioButtonValueAccessor = (function () {
    function SuiRadioButtonValueAccessor(host) {
        this.host = host;
        this.onChange = function () { };
        this.onTouched = function () { };
    }
    SuiRadioButtonValueAccessor.prototype.writeValue = function (value) {
        this.host.writeValue(value);
    };
    SuiRadioButtonValueAccessor.prototype.registerOnChange = function (fn) { this.onChange = fn; };
    SuiRadioButtonValueAccessor.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
    SuiRadioButtonValueAccessor.decorators = [
        { type: Directive, args: [{
                    selector: 'sui-radio-button',
                    host: { '(currentValueChange)': 'onChange($event)' },
                    providers: [CUSTOM_VALUE_ACCESSOR]
                },] },
    ];
    /** @nocollapse */
    SuiRadioButtonValueAccessor.ctorParameters = function () { return [
        { type: SuiRadioButton, },
    ]; };
    return SuiRadioButtonValueAccessor;
}());
export var SUI_RADIOBUTTON_DIRECTIVES = [SuiRadioButton, SuiRadioButtonValueAccessor];
//# sourceMappingURL=radiobutton.js.map