import { Component, Input, Output, HostBinding, HostListener, EventEmitter } from '@angular/core';
export var SuiDimmer = (function () {
    function SuiDimmer() {
        this.classes = true;
        this.isClickable = true;
        this.isDimmed = false;
        this.isDimmedChange = new EventEmitter(false);
    }
    SuiDimmer.prototype.click = function () {
        if (this.isClickable) {
            this.isDimmed = false;
            this.isDimmedChange.emit(this.isDimmed);
        }
    };
    SuiDimmer.decorators = [
        { type: Component, args: [{
                    selector: 'sui-dimmer',
                    exportAs: 'suiDimmer',
                    template: "\n<div class=\"content\">\n    <div class=\"center\">\n        <ng-content></ng-content>\n    </div>\n</div>\n",
                    styles: ["\n:host.dimmer {\n    transition: visibility 0.3s, opacity 0.3s ease;\n    display: block;\n    visibility: hidden;\n}\n\n:host.active {\n    visibility: visible;\n}\n"]
                },] },
    ];
    /** @nocollapse */
    SuiDimmer.ctorParameters = function () { return []; };
    SuiDimmer.propDecorators = {
        'classes': [{ type: HostBinding, args: ['class.ui',] }, { type: HostBinding, args: ['class.dimmer',] },],
        'isClickable': [{ type: Input },],
        'isDimmed': [{ type: HostBinding, args: ['class.active',] }, { type: Input },],
        'isDimmedChange': [{ type: Output },],
        'click': [{ type: HostListener, args: ['click',] },],
    };
    return SuiDimmer;
}());
export var SUI_DIMMER_DIRECTIVES = [SuiDimmer];
//# sourceMappingURL=dimmer.js.map