import { Component, Input, Output, EventEmitter } from '@angular/core';
import { Transition, TransitionDirection } from '../transition/transition';
import { TransitionController } from '../transition/transition-controller';
export var SuiMessage = (function () {
    function SuiMessage() {
        this.isDismissable = true;
        this.onDismiss = new EventEmitter(false);
        this.transition = new TransitionController();
        this.isDismissed = false;
        this.classes = "";
    }
    SuiMessage.prototype.dismiss = function () {
        var _this = this;
        this.transition.animate(new Transition("fade", 300, TransitionDirection.Out, function () {
            _this.isDismissed = true;
            _this.onDismiss.emit(_this);
        }));
    };
    SuiMessage.decorators = [
        { type: Component, args: [{
                    selector: 'sui-message',
                    template: "\n<div class=\"ui message {{ classes }}\" *ngIf=\"!isDismissed\" [suiTransition]=\"transition\">\n    <i class=\"close icon\" *ngIf=\"isDismissable\" (click)=\"dismiss()\"></i>\n    <ng-content></ng-content>\n</div>\n"
                },] },
    ];
    /** @nocollapse */
    SuiMessage.ctorParameters = function () { return []; };
    SuiMessage.propDecorators = {
        'isDismissable': [{ type: Input },],
        'onDismiss': [{ type: Output },],
        'classes': [{ type: Input, args: ["class",] },],
    };
    return SuiMessage;
}());
//# sourceMappingURL=message.js.map