/// <reference types="node" />
export declare type LookupFn<T> = (query: string) => Promise<T[]>;
export declare class SearchService<T> {
    private _options;
    private _optionsLookup;
    private _optionsField;
    options: T[];
    optionsLookup: LookupFn<T>;
    optionsField: string;
    private _results;
    private _resultsCache;
    readonly results: T[];
    private _query;
    allowEmptyQuery: boolean;
    searchDelay: number;
    private _searchDelayTimeout;
    private _isSearching;
    readonly query: string;
    readonly isSearching: boolean;
    constructor(allowEmptyQuery?: boolean);
    updateQueryDelayed(query: string, callback?: (err?: Error) => void): void;
    updateQuery(query: string, callback?: (err?: Error) => void): void;
    private updateResults(results);
    private toRegex(query);
    highlightMatches(text: string): string;
    private reset();
}
