var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { Component, Input, HostBinding, EventEmitter, ViewContainerRef, ViewChild, Renderer, ElementRef, Output } from '@angular/core';
import { SuiTransition, Transition, TransitionDirection } from '../transition/transition';
import { TransitionController } from '../transition/transition-controller';
export var SuiMultiSelectLabel = (function (_super) {
    __extends(SuiMultiSelectLabel, _super);
    function SuiMultiSelectLabel(renderer, element) {
        _super.call(this, renderer, element);
        // Initialise transition functionality.
        this._transitionController = new TransitionController(false, "inline-block");
        this.setTransitionController(this._transitionController);
        this.onDeselected = new EventEmitter();
        this.readLabel = function (value) { return ""; };
        this.usesTemplate = false;
        this._labelClasses = true;
        this._transitionController.animate(new Transition("scale", 100, TransitionDirection.In));
    }
    SuiMultiSelectLabel.prototype.deselectOption = function (event) {
        var _this = this;
        event.stopPropagation();
        this._transitionController.animate(new Transition("scale", 100, TransitionDirection.Out, function () {
            return _this.onDeselected.emit(_this.value);
        }));
    };
    SuiMultiSelectLabel.decorators = [
        { type: Component, args: [{
                    selector: 'sui-multi-select-label',
                    template: "\n<span #templateSibling></span>\n<span *ngIf=\"!usesTemplate\">{{ readLabel(value) }}</span>\n<i class=\"delete icon\" (click)=\"deselectOption($event)\"></i>\n"
                },] },
    ];
    /** @nocollapse */
    SuiMultiSelectLabel.ctorParameters = function () { return [
        { type: Renderer, },
        { type: ElementRef, },
    ]; };
    SuiMultiSelectLabel.propDecorators = {
        '_labelClasses': [{ type: HostBinding, args: ['class.ui',] }, { type: HostBinding, args: ['class.label',] },],
        'value': [{ type: Input },],
        'onDeselected': [{ type: Output },],
        'templateSibling': [{ type: ViewChild, args: ['templateSibling', { read: ViewContainerRef },] },],
    };
    return SuiMultiSelectLabel;
}(SuiTransition));
//# sourceMappingURL=multi-select-label.js.map