import { ElementRef, AfterContentInit, Renderer, TemplateRef, ViewContainerRef } from '@angular/core';
import { DropdownService } from '../dropdown/dropdown.service';
import { SearchService } from '../search/search.service';
import { SuiDropdownMenu } from '../dropdown/dropdown-menu';
import { ISelectRenderedOption } from './select-option';
export declare abstract class SuiSelectBase<T, U> implements AfterContentInit {
    private _element;
    private _renderer;
    dropdownService: DropdownService;
    searchService: SearchService<T>;
    protected _menu: SuiDropdownMenu;
    private _renderedOptions;
    private _renderedSubscriptions;
    private _selectClasses;
    readonly isActive: boolean;
    readonly isVisible: boolean;
    isSearchable: boolean;
    readonly tabIndex: number;
    isDisabled: boolean;
    private _queryInput;
    placeholder: string;
    options: T[];
    protected optionsUpdateHook(): void;
    readonly availableOptions: T[];
    query: string;
    protected queryUpdateHook(): void;
    labelField: string;
    private readonly labelGetter;
    valueField: string;
    protected readonly valueGetter: (obj: T) => U;
    optionTemplate: TemplateRef<any>;
    noResultsMessage: string;
    constructor(_element: ElementRef, _renderer: Renderer);
    ngAfterContentInit(): void;
    protected onAvailableOptionsRendered(): void;
    protected initialiseRenderedOption(option: ISelectRenderedOption<T>): void;
    selectOption(option: T): void;
    onClick(e: MouseEvent): void;
    onKeypress(e: KeyboardEvent): void;
    protected focusInput(): void;
    protected drawTemplate(siblingRef: ViewContainerRef, value: T): void;
}
