var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { Component, Input, HostBinding, HostListener, EventEmitter, ViewContainerRef, ViewChild, Renderer, ElementRef, Output } from '@angular/core';
import { SuiDropdownMenuItem } from '../dropdown/dropdown-menu';
export var SuiSelectOption = (function (_super) {
    __extends(SuiSelectOption, _super);
    function SuiSelectOption(renderer, element) {
        // We inherit SuiDropdownMenuItem to automatically gain all keyboard navigation functionality.
        // This is not done via adding the .item class because it isn't supported by Angular.
        _super.call(this, renderer, element);
        this._optionClasses = true;
        this.isActive = false;
        this.onSelected = new EventEmitter();
        // By default we make this function return an empty string, for the brief moment when it isn't displaying the correct label.
        this.readLabel = function (value) { return ""; };
        this.usesTemplate = false;
    }
    SuiSelectOption.prototype.onClick = function (event) {
        event.stopPropagation();
        this.onSelected.emit(this.value);
    };
    SuiSelectOption.decorators = [
        { type: Component, args: [{
                    selector: 'sui-select-option',
                    template: "\n<span #templateSibling></span>\n<span *ngIf=\"!usesTemplate\">{{ readLabel(value) }}</span>\n"
                },] },
    ];
    /** @nocollapse */
    SuiSelectOption.ctorParameters = function () { return [
        { type: Renderer, },
        { type: ElementRef, },
    ]; };
    SuiSelectOption.propDecorators = {
        '_optionClasses': [{ type: HostBinding, args: ['class.item',] },],
        'value': [{ type: Input },],
        'onSelected': [{ type: Output },],
        'isActive': [{ type: HostBinding, args: ['class.active',] },],
        'templateSibling': [{ type: ViewChild, args: ['templateSibling', { read: ViewContainerRef },] },],
        'onClick': [{ type: HostListener, args: ['click', ['$event'],] },],
    };
    return SuiSelectOption;
}(SuiDropdownMenuItem));
//# sourceMappingURL=select-option.js.map