import { Directive, Input, Output, HostBinding, HostListener, EventEmitter } from '@angular/core';
import { Observable } from "rxjs";
export var SuiTab = (function () {
    function SuiTab() {
        var _this = this;
        this._isActive = false;
        this._isDisabled = false;
        this.isActiveChange = new EventEmitter(false);
        this.onActivate = new EventEmitter(false);
        this.stateChanged$ = new Observable(function (observer) {
            _this._stateObserver = observer;
            _this._stateObserver.next(_this);
        });
    }
    Object.defineProperty(SuiTab.prototype, "suiTabHeader", {
        set: function (value) {
            if (!this.id) {
                this.id = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiTab.prototype, "content", {
        get: function () { return this._content; },
        set: function (content) {
            this._content = content;
            content.isActive = this.isActive;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiTab.prototype, "isActive", {
        get: function () { return this._isActive; },
        set: function (value) {
            var change = this._isActive != value;
            this._isActive = value;
            if (this._content) {
                this._content.isActive = value;
            }
            this.stateObserverNext(change);
            this.isActiveChange.emit(this._isActive);
            if (value && change) {
                this.onActivate.emit(this);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiTab.prototype, "isDisabled", {
        get: function () {
            return this._isDisabled;
        },
        set: function (value) {
            var change = this._isDisabled != value;
            this._isDisabled = value;
            this.stateObserverNext(change);
        },
        enumerable: true,
        configurable: true
    });
    SuiTab.prototype.stateObserverNext = function (change) {
        if (change && this._stateObserver) {
            this._stateObserver.next(this);
        }
    };
    Object.defineProperty(SuiTab.prototype, "manuallyActivate", {
        set: function (value) {
            var _this = this;
            setTimeout(function () {
                _this.isActive = _this.isDisabled ? false : value;
                _this.isActiveChange.emit(_this._isActive);
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiTab.prototype, "manuallyDisable", {
        set: function (value) {
            var _this = this;
            setTimeout(function () {
                _this.isDisabled = value;
            });
        },
        enumerable: true,
        configurable: true
    });
    SuiTab.prototype.click = function () {
        if (!this.isDisabled) {
            this.isActive = true;
        }
    };
    SuiTab.decorators = [
        { type: Directive, args: [{
                    selector: '[suiTabHeader]'
                },] },
    ];
    /** @nocollapse */
    SuiTab.ctorParameters = function () { return []; };
    SuiTab.propDecorators = {
        'suiTabHeader': [{ type: Input },],
        'isActive': [{ type: HostBinding, args: ['class.active',] },],
        'isDisabled': [{ type: HostBinding, args: ['class.disabled',] },],
        'manuallyActivate': [{ type: Input, args: ['isActive',] },],
        'manuallyDisable': [{ type: Input, args: ['isDisabled',] },],
        'isActiveChange': [{ type: Output },],
        'onActivate': [{ type: Output },],
        'click': [{ type: HostListener, args: ['click',] },],
    };
    return SuiTab;
}());
//# sourceMappingURL=tab.js.map