var Popper = require('popper.js');
// Creates essentially a 'string' enum.
export var PositioningPlacement = {
    Inherit: "inherit",
    TopLeft: "top-start",
    TopCenter: "top",
    TopRight: "top-end",
    LeftTop: "left-start",
    LeftCenter: "left",
    LeftBottom: "left-end",
    BottomLeft: "bottom-start",
    BottomCenter: "bottom",
    BottomRight: "bottom-end",
    RightTop: "right-start",
    RightCenter: "right",
    RightBottom: "right-end"
};
export var PositioningService = (function () {
    function PositioningService(anchor, subject, placement, arrowSelector) {
        var _this = this;
        this.anchor = anchor;
        this.subject = subject;
        var modifiers = {
            applyStyle: {
                gpuAcceleration: false
            },
            preventOverflow: {
                boundariesElement: document.body
            }
        };
        if (arrowSelector) {
            modifiers.arrow = {
                element: arrowSelector
            };
        }
        this._popper = new Popper(anchor.nativeElement, subject.nativeElement, {
            placement: placement,
            modifiers: modifiers,
            onCreate: function (initial) { return _this._popperState = initial; },
            onUpdate: function (update) { return _this._popperState = update; }
        });
    }
    Object.defineProperty(PositioningService.prototype, "placement", {
        get: function () {
            return this._popper.options.placement;
        },
        set: function (placement) {
            this._popper.options.placement = placement;
            this.update();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PositioningService.prototype, "state", {
        get: function () {
            return this._popperState;
        },
        enumerable: true,
        configurable: true
    });
    PositioningService.prototype.update = function () {
        this._popper.update();
    };
    return PositioningService;
}());
//# sourceMappingURL=positioning.service.js.map